/**
*      Head file of ControlReader Class
*      ControlReader class is used to input control parameters from control file
*    
*      Created by:    Nan Chen
*      Created date:  8/12/05
*      Last Modified: 3/7/05
*/

#ifndef CONTROLREADER_H
#define CONTROLREADER_H
// #include <stdio.h>
#include <gdecs/gdecs.h>

#define MAXTERM 100
#define MAXSUBTERM 6
#include "Potts.h"
class ControlReader
{
private:
  FILE *fin;
  bool getoneterm();

public:
  int termnumber;
  int choice;
  FILE *syslog;
  char termname[MAXTERM][50];
  double termvalue[MAXTERM][MAXSUBTERM];
  void *definevalue[MAXTERM];
  int termdefine[MAXTERM];
  int termvaluenumber[MAXTERM];
  void *getvalue(char* index);
  bool readfile(char* filename);  
  bool getselfdefine();
  bool inputenergypara(EnergyPara *pa);
  ControlReader()
  {
	  for (int i = 0; i<MAXTERM; i++)
		  definevalue[i] = NULL;    
  };

  ~ControlReader()
  {
	  for (int i = 0; i<MAXTERM; i++)
	  {
		  if (definevalue[i])
		  {
			  delete[] definevalue[i];
			  definevalue[i] = NULL;   	  
		  }
	  }
  };
};
#endif
