#include <gdecs/gdecs.h>
#include <stdio.h>

#include "Node.h"
#include <cpm/cpmprotos.h>

EXPORT POINTER g_Cpm_init(
       Wave    *wv,
       Front   *fr)
{
    Node *sim = new Node;
    FILE *syslog = fopen("Syslog.txt","a+t");
    
    if (!sim)    
    {
        std::cout << "Memory is not enough for Node in Sysmanager "<< std::endl;
        fprintf(syslog, "Memory is not enough for Node in Sysmanager \n");
        //return (false);
    }
	    
            
    fprintf (syslog, "Node is constructed\n");
    
    sim->syslog = syslog;
    sim->currenttime = 0;
    sim->runningmode = 1;
    bool t = sim->init();
    if (!t)
    {
        std::cout << "Node initialization error! "<< std::endl;
        fprintf(syslog, "Node initialization error! \n");
        //return (false);
    
    }
    sim->preRun();
    sim->wv = wv;
    sim->fr = fr;
    
    
    return (POINTER) sim;
    
}


EXPORT int g_Cpm_Clot_driver(
       Wave       *wv,
       Front      *fr,
       float      dt,
       COMPONENT  lcomp,
       COMPONENT  bubcomp)
{
    Node *sim = (Node*)(wv->Cpm_Node_ptr);
    sim->oneTimeStep();
        			
}

EXPORT int g_Cpm_modify_wave_state(
       Wave       *wv,
       Front      *fr,
       COMPONENT  lcomp,
       COMPONENT  bubcomp)
{
    float *crds, v[MAXD];
    int   dim = wv->rect_grid->dim, ix, iy, celltype, ic[MAXD], i, ic2[MAXD];
    RECT_GRID *gr = wv->rect_grid;
    float     *L = gr->L, *U = gr->U;
    Locstate  state = NULL;

    Node *sim = (Node*)(wv->Cpm_Node_ptr);

    if (2 == dim)
    {
        for(iy = 0; iy < gr->gmax[1]; iy++)
        {
	    for(ix = 0; ix < gr->gmax[0]; ix++)
    	    {
                ic2[0] = ic[0] = ix; ic2[1] = ic[1] = iy;
                crds = Rect_coords(ic,wv);
                ic[0] = (int)((crds[0]-L[0])/(U[0]-L[0])*500);
                ic[1] = (int)((crds[1]-L[1])/(U[1]-L[1])*250);

                celltype = sim->getcelltype(ic[0], ic[1], 0);

		if(celltype == 3 || celltype == 2)
                {
                    state = Rect_state(ic2,wv);
                    Vel(state)[0] = 0.0; 
                    Vel(state)[1] = 0.0;
                } 
            }
        }
    }
    else
    {
        printf("ERROR: g_Cpm_modify_wave_state, implement %d dim case\n", dim);
        clean_up(ERROR);
    }

    return YES;
}

