/**
*      CPP file of DataReader Class
*      DataReader class is used to input a field from a file
*    
*      Created by:    Nan Chen
*      Created date:  8/12/05
*      Last Modified: 10/11/05
*/

#include "DataReader.h"

//#include <iostream>
#include <gdecs/gdecs.h>
// #include <stdlib.h>

bool DataReader::noderead(char* filename, SingleMap *field )
{
    if (filemode == 1)
    {
        
        // Open file
        FILE *fin = fopen(filename, "rt");
        if (!fin)
        {
            std::cout<<"Can not open file: "<<filename<<std::endl;
            fprintf(syslog, "Can not open file: %s\n", filename);

            return(false);
        }

        // Read dimension information
        int x,y,z;
        fscanf(fin, "%d %d %d", &x, &y, &z);
        field->dimensionsize[0] = x;
        field->dimensionsize[1] = y;
        field->dimensionsize[2] = z;

        if(!field->value)
        {
            // Initilize memory for field
            CPMPoint tepoint(x, y, z);
            bool te= field->init(tepoint);
            if (!te)
                return (false);
        }

        // Start to read and default initnode is 0 from file
        int i,j,k;
        for (i = 0; i < z; i++)
            for (j =0; j < y; j++)
                for (k = 0; k < x; k++)
                {
                    int id;
		            int  cellty;
                    Site tesite;
                    fscanf(fin, "%d %d", &id, &cellty);
                    tesite.cellID = id;
                    tesite.celltype = (unsigned char) cellty;
                    tesite.cellID = id;
                    field->setsite(k, j, i, tesite);
                }
                fclose(fin);

                return (true);
    }
    return (false);
}
