/**
*      Head file of EnergyPara Class
*      EnergyPara class provides the information of energy function parameters
*      
*      Created by:    Nan Chen
*      Created date:  8/17/05
*      Last Modified: 8/24/05
*/

#ifndef ENERGYPARA_H
#define ENERGYPARA_H
#define MAXCELLTYPE 80
// #include <iostream>
#include <gdecs/gdecs.h>

class EnergyPara
{
public:
    int celltypenum;
    double contactenergy[MAXCELLTYPE+1][MAXCELLTYPE+1];
    double volume[MAXCELLTYPE+1];
    double volumeconstant[MAXCELLTYPE+1];
    double fluidconstant[MAXCELLTYPE+1];
    double getcontact(int i, int j)
    {
        if (i < 0)
        {
            std::cout<<"Wrong cell type number"<<i<<std::endl;
            return (20);
        }
        return (contactenergy[i][j]);
    };
    double getvolume (int cellty, double vo, double voobj)
    {
        double diff = vo-voobj;
        return (volumeconstant[cellty] * diff *diff);
    }; 
    double getvolume (int cellty, double vol)
    {
        double diff = vol-volume[cellty];
        return (volumeconstant[cellty] * diff *diff);
    }; 
    double getfluid(int cellty)
    {
	return fluidconstant[cellty];
    }
};
#endif

