/**
 *      CPP file for LogicNode Class
 *      LogicNode class is used as a logic node
 *      It proveds basic input and output for "field" data
 *      It has been embeded into Node class, and Node class can switch them 
 *      
 *      Created by:    Nan Chen
 *      Created date:  8/10/05
 *      Last Modified: 8/24/05
 */

#include "LogicNode.h"
#include "DataReader.h"
// #include <stdlib.h>

LogicNode::LogicNode()
{
    filereader = NULL;
    filewriter = NULL;
    field = NULL;
}

LogicNode::~LogicNode()
{
    if (filereader)
    {
        delete filereader;
        filereader = NULL;
    }
    if (filewriter)
    {
        delete filewriter;
        filewriter = NULL;
    }
    if (field)
    {
        delete field;
        field = NULL;
    }

}

bool LogicNode::init()
{

    filereader = new DataReader;
    filewriter = new DataWriter;
	
    if (!filereader || !filewriter)
    {
        fprintf (syslog, "No enough memory for DATA IO on logicnode\n");
        return (false);
    }
    return (true);
}
bool LogicNode::getfield(char * filename)
{
    bool t = filereader->noderead(filename, field);
    return (t);
}

bool LogicNode::savefield(char *filename)
{
    filewriter->nodewrite(filename, field);
    return (true);
}


