/**
 *      Head file for Logic Node Class
 *      LogicNode class is used as a logic node
 *      It proveds basic input and output for "field" data
 *      It has been embeded into Node class, and Node class can switch them 
 *      
 *      Created by:    Nan Chen
 *      Created date:  8/17/05
 *      Last Modified: 3/6/05
 */

#ifndef LOGICNODE_H
#define LOGICNODE_H
#include "SingleMap.h"
#include "Potts.h"
#include "DataReader.h"
#include "DataWriter.h"
// #include <stdlib.h>

#include <gdecs/gdecs.h>

class Node;
class LogicNode
{
    private:
        DataReader *filereader;
        DataWriter *filewriter;
    public:
        int nodeID;
        int logicID;
        int globeID;
        CPMPoint location;
        SingleMap *field;
        FILE *syslog;


        int setlogicID(int i)
        {
            logicID = i;
        };
        int setglobeID(int i)
        {
            globeID = i;
        }
        bool getfield(char *filename);
        bool savefield(char *filename);
        SingleMap *getbuffer(int index);
        bool init();
        LogicNode();
        ~LogicNode();
        friend class Node;
        friend class Grid2D;
};
#endif
