/**
 *      CPP file for NeighborCal Class
 *      LogicNode class is used for Neighbor searching
 *      
 *      Created by:    Nan Chen
 *      Created date:  8/8/05
 *      Last Modified: 8/24/05
 */

#include "NeighborCal.h"
#define TWODMAX 30
#define THREEDMAX 100
void NeighborCal::initdis ()
{
    if (dimension == 2)
    {
        displace = new CPMPoint[TWODMAX];
        disnum = 0;
        for ( int x = -1; x <=  1; x++)
            for ( int y = -1; y <= 1; y++)
        {
            if (x == 0 && y == 0) continue;
            CPMPoint tepo;
            tepo.cor[0] = x;
            tepo.cor[1] = y;      
            tepo.cor[2] = 0;
            displace[disnum] = tepo;
            disnum++;
        }
    }  
}

void NeighborCal::setup (SingleMap *single)
{
    for ( int i = 0; i < 3; i++)
    {
        size[i] = single->getsize(i);
    }
    dimension = single->dimension;
    initdis();
}

void NeighborCal::getlist(CPMPoint &po)
{
    resultnum = 0;
    for (int i= 0;i < disnum; i++)
    {
        CPMPoint tepo;
        tepo = po +displace[i];
//        correctrange (tepo);
        result[i] = tepo;
        resultnum++;
    }
}

void NeighborCal::correctrange (CPMPoint &po)
{
    for (int i = 0; i < 3; i ++)
    {
        if (po.cor[i] >= size [i])
            po.cor[i] -= size[i];
        if (po.cor[i] <0)
            po.cor[i] += size[i];
    }
}


