/**
*      Head file for NeighborCal Class
*      LogicNode class is used for Neighbor searching
*      
*      Created by:    Nan Chen
*      Created date:  8/8/05
*      Last Modified: 8/24/05
*/

#ifndef NeighborCal_H
#define NeighborCal_H


// #include <iostream>
#include <gdecs/gdecs.h>
#include "SingleMap.h"

#define MAX_NEIGHBOR 100
class Potts;

class NeighborCal
{
private:
	CPMPoint* displace;
	int disnum;

public:
	int size[3];
	CPMPoint* result;
	int resultnum;
	int dimension;
	NeighborCal() 
	{ 
		dimension = 2; 
		result = new CPMPoint[MAX_NEIGHBOR];  
		if (!result)
		{  
			std::cout<<"Memeory is not enought in NeighborCal"<<std::endl;
			exit(4);
		}
		displace = new CPMPoint[MAX_NEIGHBOR];
		if (!displace)
		{  
			std::cout<<"Memeory is not enought in NeighborCal"<<std::endl;
			exit(4);
		}
	};
	~NeighborCal() 
	{
		if (displace)
		{
			delete[] displace;
			displace = NULL;
		}
		if (result)
		{
			delete[] result;
			result = NULL;
		}
	};
	void initdis();
	void setup(SingleMap *single);
	void getlist(CPMPoint &po);
	void correctrange (CPMPoint &po);
	friend class Potts;
};
#endif

