/**
*      Head file for Point Class
*      Point class provides basic functions for point operations in 3D
*      
*      Created by:    Nan Chen
*      Created date:  8/4/05
*      Last Modified: 3/7/05
*/

#ifndef POINT_H
#define POINT_H
// #include <iostream>

#include <gdecs/gdecs.h>

class CPMPoint
{
public:

    int cor[3];

    /************************************************************
    * Constructor
    * 
    ************************************************************/

    CPMPoint() {cor[0] = cor[1] = cor[2] = 0; };

    CPMPoint(const short x, const short y, const short z) 
    { cor[0] = x; cor[1] = y; cor[2] = z; }; 

    /************************************************************
    * Constructor
    * 
    ************************************************************/

    CPMPoint(const CPMPoint &pt) { cor[0] = pt.cor[0]; cor[1] = pt.cor[1]; cor[2] = pt.cor[2];};

    /************************************************************
    * Operator =
    * 
    ************************************************************/

    void operator = (const CPMPoint &pt) 
    { 
        cor[0] = pt.cor[0]; cor[1] = pt.cor[1]; cor[2] = pt.cor[2];
        return;
    };

    /************************************************************
    * Operator ==
    * 
    ************************************************************/

    bool operator==(const CPMPoint pt) 
    {
        return (cor[0] == pt.cor[0] && cor[1] == pt.cor[1] && cor[2] == pt.cor[2]);
    };

    inline std::string _str() 
    {
        std::string s;

        s='(' + cor[0] + ',' 
            + cor[0] + ',' 
            + cor[0] + ')';
        return s;
    };
};
/************************************************************
* Output a point to stream
* The format is (x,y,z).
************************************************************/
inline std::ostream& operator<<(std::ostream &stream, const CPMPoint &pt)
{
    stream << '(' << pt.cor[0] << ',' << pt.cor[0] << ',' << pt.cor[0] << ')';
    return stream;
};

/************************************************************
* Oerator +
* 
************************************************************/

inline CPMPoint operator+(const CPMPoint &pt1, const CPMPoint &pt2) 
{
    return CPMPoint(pt1.cor[0] + pt2.cor[0], pt1.cor[1] + pt2.cor[1], pt1.cor[2] + pt2.cor[2]);
};

/************************************************************
* Oerator -
* 
************************************************************/

inline CPMPoint operator-(const CPMPoint &pt1, const CPMPoint &pt2) 
{ 
    return CPMPoint(pt1.cor[0] - pt2.cor[0], pt1.cor[1] - pt2.cor[1], pt1.cor[2] - pt2.cor[2]);
};
#endif 


