/**
*      Cpp file of Potts Class
*      Potts class is responsible for main Potts model loop
*      
*      Created by:    Nan Chen
*      Created date:  8/17/05
*      Last Modified: 3/8/05
*/

#ifndef POTTS_H
#define POTTS_H

#include "Cell.h"
#include "SingleMap.h"
#include "CellMap.h"
#include "Accept.h"
#include "Automation.h"
#include "EnergyPara.h"
#include "NeighborCal.h"
#include "Flip.h"
#include "ChemField.h"


class Node;
class LogicBuffer;

class Potts
{
private:
	NeighborCal *neibor;	
	CellMap *cells;
	SingleMap *field;
	ChemField *chem;
	Flip getrandomflip();
	CPMPoint randomposition();
	double getcontactchange (Flip &fl);
	double getvolumechange (Flip &fl);
	double getFluid(Flip &fl);
	double getchemicalchange (Flip &fl);

public:

	FILE *syslog;
	Accept *acceptptr;
	Automation *automationptr;
	EnergyPara *enpara;
	LogicBuffer *buffer;
	Node *node;
	int bufferupdatefrequency;

	bool sitesuccess;	
	int currenttime;
	int runnumber;
	double currentenergy;
	void getV(double *v, int x, int y, int z);
	double getSurfaceVel();

	int allsteps;
	int writefrequency;

	void onestep();
	void oneflip();
	void updateType();
	bool testsite (Site &test, CPMPoint &po);
	bool init();
	bool initmember();
	bool run();
	double getcontact();
	Site getsite(CPMPoint &tepo);
	double getvolume();
	int getcelltype(int x, int y, int z);
	double getchemical();
	void acceptflip(Flip &fl);         
	void getcells();
	Potts();
	~Potts();
	friend class Node;
};
#endif
