/**
 *      CPP file for SingleMap Class
 *      SingleMap class is used to describe a field
 *      It provides basic function for field IO
 *      
 *      Created by:    Nan Chen
 *      Created date:  8/6/05
 *      Last Modified: 8/24/05
 */

#include "SingleMap.h"

bool SingleMap::init (CPMPoint &dimension)
{
    if (value)
    {
        delete[] value;
    }
    dimensionsize[0] = dimension.cor[0];
    dimensionsize[1] = dimension.cor[1];
    dimensionsize[2] = dimension.cor[2];
    sitenumber = dimensionsize[0] * dimensionsize[1] *dimensionsize[2];
    value = new Site [sitenumber];
    if (!value)
        return (false);
    else
        return (true);        
}

bool SingleMap::getbuffer(CPMPoint &pt1, CPMPoint &pt2)
{
    for (int i=0; i<3; i++)
    {
        if (pt1.cor[i] > pt2.cor[i])
        {
            int te = pt1.cor[i];
            pt1.cor[i] = pt2.cor[i];
            pt2.cor[i] = te;
        }
		
    }
    bufferlen = 0;
    if (buffer)
    {
        delete[] buffer;
        buffer = NULL;
    }
    CPMPoint pt3 = pt2 - pt1;
    int num = pt3.cor[0] * pt3.cor[1] * pt3.cor[2];
    buffer = new Site[num];
    if (!buffer)
    {
        return (false);
    }
    for (int x = pt1.cor[0]; x < pt2.cor[0]; x++)
        for (int y = pt1.cor[1]; y < pt2.cor[1]; y++)
            for (int z = pt1.cor[2]; z < pt2.cor[2]; z++)
    {
        buffer[bufferlen] = getsite(x, y, z);
        bufferlen++;
    };
    if (bufferlen != num)
        return (false);
    return (true);
}

SingleMap::~SingleMap()
{
    if (value)
    {
        delete[] value;
        value = NULL;
    }
    if (buffer)
    {
        delete[] buffer;
        buffer = NULL;
    }
}

SingleMap::SingleMap()
{
    value = NULL;
    sitenumber = 0;
    buffer = NULL;
    for (int i= 0; i<3; i++)
    {
        location[i] = 0;
        dimensionsize[i] = 0;
    }
    dimension = 0;
}

