/**
*      Head file for SingleMap Class
*      SingleMap class is used to describe a field
*      It provides basic function for field IO
*      
*      Created by:    Nan Chen
*      Created date:  8/6/05
*      Last Modified: 8/24/05
*/

#ifndef SINGLEMAP_H
#define SINGLEMAP_H
#include "Site.h"
#include "Point.h"

class SingleMap
{
public:
    Site *value;
    int location[3];
    int dimensionsize[3];
    long int sitenumber;
    int dimension;
    Site *buffer;
    int bufferlen;

    Site getsite(CPMPoint &pt) 
    {
        return (value[pt.cor[0] * dimensionsize[2] * dimensionsize[1] 
        + pt.cor[1] * dimensionsize[2] + pt.cor[2]]);
    };

    Site getsite(int x, int y, int z)
    {
        return(value[x * dimensionsize[2] * dimensionsize[1] + y * dimensionsize[2] + z]);
    }

    void setsite (CPMPoint &pt, Site &st)
    {
        value[pt.cor[0] * dimensionsize[2] * dimensionsize[1] 
        + pt.cor[1] * dimensionsize[2] + pt.cor[2]]=st;
    };

    void setsite (int x, int y, int z, Site &st)
    {
        value[x * dimensionsize[2] * dimensionsize[1] + y * dimensionsize[2] + z]=st;
    };

    bool init (CPMPoint & dimension);

    int getsize (int i)
    { return dimensionsize[i];};

    bool getbuffer(CPMPoint &pt1, CPMPoint &pt2);

    SingleMap();
    ~SingleMap();

};
#endif

