#include <ghyp/ghyp.h>
#include <gdecs/vecdecs.h>

EXPORT int g_Partical_move(
	Wave      *wv,
        Front     *fr,
        Pots_Loc  *ploc,
        COMPONENT comp,
        COMPONENT bubcomp) 
{
        RECT_GRID   *p_gr = &(ploc->comp_grid);
        int         i, ic[MAXD], ix, iy, dim = p_gr->dim;
        float       crds_org[MAXD], crds[MAXD], crds_new[MAXD], dt = fr->dt;
        float       *dh = p_gr->h, dist, dist_comp[MAXD];
        static Locstate  state = NULL;
        int    pots_move = 0, active = 0, x_mov = 0, y_mov = 0;
        int    total_pots = 0;

        if(state == NULL)
        {
            alloc_state(fr->interf,&state,fr->sizest);
            ic[0] = ic[1] = 0;
        }
      
        // printf("print pots location, [%d %d]\n", p_gr->gmax[0], p_gr->gmax[1]);

        for(iy = 0; iy < p_gr->gmax[1]; iy++)
        {
            for(ix = 0; ix < p_gr->gmax[0]; ix++)
            {
                ic[0] = ix; ic[1] = iy;

                Pots_vel(ic,ploc)[0] = Pots_vel(ic,ploc)[1] = 0;

                /*
                if(ix >= 197 && ploc->status[ix][iy] == 1)
                {
                    Pots_vel(ic,ploc)[0] = 1;
                    total_pots++;
                    continue;
                }
                */

                if(ploc->status[ix][iy] == 1 ||
                   ploc->status[ix][iy] == 2)
                {
                    for(i = 0; i < dim; i++)
                        crds_new[i] = Pots_new_crds(ic,ploc)[i];
                    for(i = 0; i < dim; i++)
                        crds_org[i] = Pots_crds(ic,ploc)[i];

                    total_pots++;
                    
                    // for(i = 0; i < dim; i++) 
                    //     crds[i] = Pots_crds(ic,ploc)[i];
                    hyp_solution(crds_new,comp,NULL,UNKNOWN_SIDE,
                        fr,wv,state,NULL);

                    for(i = 0; i < dim; i++) 
                        crds[i] = crds_new[i] + dt*Vel(state)[i];
               
                    // if the space is occupied by bubbles, platelet 
                    // is removed
                    if(YES == pt_in_bubble(fr,comp,bubcomp,crds))
                    {
                        ploc->status[ix][iy] = 0;
                        continue;
                    }

                    // NEW, do not init in the obstacle
                    if( YES == is_excluded_comp(long_component(crds,fr->interf),
                             fr->interf) )
                    { 
                        ploc->status[ix][iy] = 0;
                        continue;
                    }


                    for(i = 0; i < dim; i++)
                        Pots_new_crds(ic,ploc)[i] = crds[i];

                    dist = distance_between_positions(crds,crds_org,dim);
                    for(i = 0; i < dim; i++)
                        dist_comp[i] = crds[i] - crds_org[i];

                    if(fabs(dist_comp[1]) >= dh[1])
                    {
                        /**
                        printf("Ymoved pots[%d %d] %g > dh, dt %g, vel(%g %g) dh [%g %g] from (%g %g) to (%g %g)\n",
                                 ic[0], ic[1], dist, 
                               dt, Vel(state)[0], Vel(state)[1], dh[0], dh[1],
                               crds_org[0], crds_org[1], crds[0], crds[1]);
                        **/  
                        if(dist_comp[1] > 0.0)
                            Pots_vel(ic,ploc)[1] = 1;
                        else
                            Pots_vel(ic,ploc)[1] = -1;
                        for(i = 0; i < dim; i++)
                            Pots_new_crds(ic,ploc)[i] = Pots_crds(ic,ploc)[i] = crds[i];
                        pots_move++;
                        y_mov++;
                    }

                    if(fabs(dist_comp[0]) >= dh[0])
                    {
                        if(dist_comp[0] > 0.0)
                            Pots_vel(ic,ploc)[0] = 1;
                        else
                            Pots_vel(ic,ploc)[0] = -1;
                        for(i = 0; i < dim; i++)
                            Pots_new_crds(ic,ploc)[i] = Pots_crds(ic,ploc)[i] = crds[i];
                        pots_move++;
                        x_mov++;
                        /**
                        printf("Xmoved pots[%d %d] %g vel(%g %g) dh[%g] from (%g %g) to (%g %g) i-vel %d\n",
                                 ic[0], ic[1], dist,
                               Vel(state)[0], Vel(state)[1], dh[0],
                               crds_org[0], crds_org[1], crds[0], crds[1],
                               Pots_vel(ic,ploc)[0]);
                        **/
                    }
                }
            }
        }

        for(iy = 0; iy < p_gr->gmax[1]; iy++)
        {
            // printf("Row[%d] ", iy);
            for(ix = 0; ix < p_gr->gmax[0]; ix++)
            {
                // if(ploc->a[ix+1][iy+1] == 1 && ploc->p[ix+1][iy+1] == 2)
                if(ploc->status[ix][iy] == 2)
                {
                    // printf("activatied [%d %d %d]\n", ix, iy, ploc->p[ix+1][iy+1]);
                    active++;
                }
            }
            // printf("\n");   
        }

        // printf("step %d, pots location active = %d, total %d, move %d x_mov %d y_mov %d\n",
        //                  fr->step, active, total_pots, pots_move, x_mov, y_mov);
        if(pots_move != 0)
            return YES;
        return NO;
}


EXPORT int g_modify_wave_by_pots(
	Wave      *wv,
        Front     *fr,
        Pots_Loc  *ploc) 
{
        RECT_GRID   *pgr = &(ploc->comp_grid);
        RECT_GRID   *gr = wv->rect_grid;
        int         i, ic[MAXD], ix, iy, dim = pgr->dim;
        int         icwv[MAXD];
        float       crds[MAXD], dt = fr->dt;
        float       *dh = pgr->h, dist, dist_comp[MAXD];
        COMPONENT   comp = -1;
        Locstate    state = NULL;
        int         modified = NO;

        for(iy = 0; iy < pgr->gmax[1]; iy++)
        {
            for(ix = 0; ix < pgr->gmax[0]; ix++)
            {
                if(3 == ploc->status[ix][iy])
                {
                    ic[0] = ix; ic[1] = iy;
                    for(i = 0; i < dim; i++)
                       crds[i] = pgr->L[i] + pgr->h[i]*(0.5+ic[i]);
                    if(rect_in_which(crds,icwv,gr) == YES)
                    {
                        state = Rect_state(icwv,wv);
                        // Rect_comp(icwv,wv) = POTS_COMP;
                        // for(i = 0; i < dim; i++)
                        //     Vel(state)[i] = 0.0;
                        Vel(state)[0] = 0.01; //0.3
                        Vel(state)[1] = 0.0;
                        printf("step[%d] cell[%d %d] occupied by pots\n", 
                           fr->step, icwv[0], icwv[1]);
                        modified = YES;
                    }
                }
            }
        }

        return modified;
}

EXPORT int  g_Bub_close_to_obstacle(
        POINTER    wv,
        Front      *fr,
        CURVE      *curve,
        COMPONENT  l_comp,
        COMPONENT  bubblecomp)
{
        Wave   *wave = (Wave*)wv;
        Pots_Loc  *ploc = wave->Pots_loc;
        RECT_GRID   *pgr = &(ploc->comp_grid);
        int         i, ic[MAXD], ix, iy, dim = pgr->dim;
        float       crds_new[MAXD], crds[MAXD];
        float       **pt = NULL, **ptN = NULL;
        int         num_pt = 0, trapped = NO, num_ptN = 0;
        float       spacing, *dh = fr->rect_grid->h;
        CURVE       **cc;

        if(! is_closed_curve(curve))
            return NO;

        if((negative_component(curve) == l_comp &&
              positive_component(curve) == bubblecomp) ||
             (negative_component(curve) == bubblecomp &&
              positive_component(curve) == l_comp)
            )
        {

            spacing = 0.0;
            for(i = 0; i < dim; i++)
                spacing = max(spacing,dh[i]);
            spacing *= 1.0;

            pt = polygon_of_curve(curve,&num_pt);

            for(i = 0; i < num_pt; i++)
            {
                for(cc = fr->interf->curves; cc && *cc; cc++)
                {
                    if(! is_closed_curve(*cc))
                        continue;    
                    if(wave_type(*cc) != NEUMANN_BOUNDARY)
                        continue;
                    if(point_close_to_curve(pt[i],*cc,spacing,dim) == YES)
                    {
                        free(pt);
                        return YES; 
                    }
                } 
            }
        }

        if(pt != NULL) free(pt);
        return NO;
}


EXPORT int  g_Particle_inside_circle(
        POINTER    wv,
        Front      *fr,
        CURVE      *curve,
        COMPONENT  l_comp,
        COMPONENT  bubblecomp)
{
        Wave   *wave = (Wave*)wv; 
        Pots_Loc  *ploc = wave->Pots_loc;
        RECT_GRID   *pgr = &(ploc->comp_grid);
        int         i, ic[MAXD], ix, iy, dim = pgr->dim;
        float       crds_new[MAXD], crds[MAXD];
        float       **pt = NULL;
        int         num_pt = 0, trapped = NO;
        float       spacing, *dh = fr->rect_grid->h;

        if(! is_closed_curve(curve))
            return NO;

        if((negative_component(curve) == l_comp &&
              positive_component(curve) == bubblecomp) ||
             (negative_component(curve) == bubblecomp &&
              positive_component(curve) == l_comp)
            )
        {

            spacing = 0.0;
            for(i = 0; i < dim; i++)
                spacing = max(spacing,dh[i]);
            spacing *= 1.5;

            pt = polygon_of_curve(curve,&num_pt);

            for(iy = 0; iy < pgr->gmax[1]; iy++)
            {
                for(ix = 0; ix < pgr->gmax[0]; ix++)
                {
                    ic[0] = ix; ic[1] = iy;
                    if(ploc->status[ix][iy] == 3)
                    {
                        for(i = 0; i < dim; i++)
                            crds_new[i] = Pots_new_crds(ic,ploc)[i];

                        // printf("clot ic[%d %d] %g %g\n", ix, iy, crds_new[0], crds_new[1]);

                        if(YES == _point_in_polygon_2d(pt, num_pt, crds_new))
                        {
                            trapped = YES;
                            break;
                        }
                        if(YES == point_close_to_curve(crds_new,curve,spacing,dim))
                        {
                            trapped = YES;
                            break;
                        }
                    }
                }
                if(trapped == YES)
                    break;
            }
        }

        if(trapped == YES)
        {
            for(iy = 0; iy < pgr->gmax[1]; iy++)
            {
                for(ix = 0; ix < pgr->gmax[0]; ix++)
                {
                    ic[0] = ix; ic[1] = iy;
                    for(i = 0; i < dim; i++)
                       crds[i] = pgr->L[i] + pgr->h[i]*(0.5+ic[i]);
                    if(YES == _point_in_polygon_2d(pt, num_pt, crds))
                    {
                        ploc->status[ix][iy] = 3;
                    }
                }
            }
            free(pt);
            return YES;
        }
 
        if(pt != NULL) free(pt);
        return NO;
}
